<?

	/**
	 * Sistema Integrado de Monitoramento do Ministrio da Educao
	 * Setor responsvel: SPO/MEC
	 * Desenvolvedor: Desenvolvedores Simec
	 * Analistas: Gilberto Arruda Cerqueira Xavier <gacx@ig.com.br>, Cristiano Cabral <cristiano.cabral@gmail.com>
	 * Programadores: Ren de Lima Barbosa <renedelima@gmail.com>, Gilberto Arruda Cerqueira Xavier <gacx@ig.com.br>, Cristiano Cabral <cristiano.cabral@gmail.com>
	 * Mdulo: Autenticao
	 * Finalidade: Rotina de autenticao de usurios.
	 * Data de criao: 24/06/2005
	 * ltima modificao: 28/08/2006
	 */
	// BIBLIOTECA //////////////////////////////////////////////////////////////
	/**
	 * Exibe mensagens de erro.
	 * 
	 * @return void
	 */

	function erro(){
		global $db;
		$db->commit();
		$_SESSION = array();
		$_SESSION['MSG_AVISO'] = func_get_args();
		header( "Location: ". $_SERVER['PHP_SELF'] );
		exit();
	}
	// CONFIGURAO ////////////////////////////////////////////////////////////

	// quantidade limite de tentativas de acesso com senha invlida
	define( 'LIMITE_DE_TENTATIVAS', 4 );

	// lista de status de usurio
	define( 'STATUS_ATIVO', 'A' );
	define( 'STATUS_PENDENTE', 'P' );
	define( 'STATUS_BLOQUEADO', 'B' );

	// mensagens de alera do sistema
	$alerta = array(
		'cpf' => "O cpf informado no est cadastrado.",
		'status_pendente' => "Sua conta est pendente para aprovao, aguarde a avaliao dos administradores.",
		'status_bloqueado' => "Sua conta est bloqueada, clique <a href='solicitar_ativacao_de_conta.php' title='solicitar ativao de conta'>aqui</a> para solicitar a ativao.",
		'senha' => "A senha informada no  vlida. Tentativas restantes: %s",
		'tentativas' => "Voc excedeu a quantidade de tentativas.",
		'permissao' => "Voc no possui permisso de acesso em nenhum dos mdulos.",
	);

	// VALIDAO ///////////////////////////////////////////////////////////////



	$_SESSION["NUM_IP_CLIENTE"] = $_SERVER["REMOTE_ADDR"];
	$_SESSION["DES_BROWSER"] = $_SERVER["HTTP_USER_AGENT"];

	// carrega os dados do formulrio

	$cpf = corrige_cpf( $_REQUEST['usucpf'] );
	$senha = trim( $_POST['ususenha'] );
	
	// carrega os dados da conta do usurio a partir do cpf informado
	$sql = sprintf(
		"SELECT 
			u.usucpf, 
			u.ususenha, 
			u.suscod, 
			u.usutentativas, 
			u.usunome, 
			u.usuemail 
		 FROM 
			seguranca.usuario u
		 WHERE 
			u.usucpf = '%s'",
		$cpf
	);

	$usuario = (object) $db->recuperar( $sql );

	// verifica se o cpf existe
	if ( !$usuario->usucpf ) {
		erro( $alerta['cpf'] );
	}

	// verifica o status do usurio
	switch ( $usuario->suscod ) {
		case STATUS_ATIVO:
			break;
		case STATUS_PENDENTE:
			erro( $alerta['status_pendente'] );
		case STATUS_BLOQUEADO:
		default:
			erro( $alerta['status_bloqueado'] );
	}

	// atribuies requeridas para que a auditoria do sistema funcione
	$_SESSION['sisid'] = 4; # seleciona o sistema de segurana
	$_SESSION['usucpf'] = $usuario->usucpf;
	$_SESSION['usucpforigem'] = $usuario->usucpf;

	// valida a senha informada
	if (md5_decrypt_senha( $usuario->ususenha, '' ) != $senha ) {
		$usuario->usutentativas += 1;
		$alerta['senha'] = sprintf( $alerta['senha'], LIMITE_DE_TENTATIVAS - $usuario->usutentativas + 1 );
		if ( $usuario->usutentativas > LIMITE_DE_TENTATIVAS ) {
			$sql = sprintf( "UPDATE seguranca.usuario SET usutentativas = 0 WHERE usucpf = '%s'", $usuario->usucpf );
			$db->executar( $sql );
			$db->alterar_status_usuario( $usuario->usucpf, STATUS_BLOQUEADO, "Usurio bloqueado por exceder a quantidade de tentativas de login com senha invlida." );
			erro( $alerta['senha'], $alerta['tentativas'], $alerta['status_bloqueado'] );
		} else {
			$sql = sprintf(
				"UPDATE seguranca.usuario SET usutentativas = %d WHERE usucpf = '%s'",
				$usuario->usutentativas,
				$usuario->usucpf
			);
			$db->executar( $sql );
			erro( $alerta['senha'] );
		}
	}
	if ( $usuario->usutentativas > 0 ) {
		$sql = sprintf( "UPDATE seguranca.usuario SET usutentativas = 0 WHERE usucpf = '%s'", $usuario->usucpf );
		$db->executar( $sql );
	}

	// carrega os dados do usurio para a sesso
	unset( $usuario->ususenha );
	foreach ( $usuario as $attribute => $value ) {
		$_SESSION[$attribute] = $value;
	}
	$_SESSION['usucpforigem'] = $usuario->usucpf;

	// verifica permisso de acesso aos mdulos
	$sql = sprintf(
		"SELECT
		s.sisid, s.sisdiretorio, s.sisarquivo, s.sisdsc, s.sisurl, s.sisabrev, s.sisexercicio, s.paginainicial, p.pflnivel AS usunivel, us.susdataultacesso
		FROM seguranca.sistema s
		INNER JOIN seguranca.usuario_sistema us USING ( sisid )
		INNER JOIN seguranca.usuario u USING ( usucpf )
		INNER JOIN seguranca.perfilusuario pu USING ( usucpf )
		INNER JOIN seguranca.perfil p ON pu.pflcod = p.pflcod AND p.sisid = s.sisid
		WHERE
		us.suscod = 'A' AND
		u.usucpf = '%s' AND
		u.suscod = 'A' AND
		p.pflstatus = 'A'
		GROUP BY s.sisid, s.sisdiretorio,  s.sisarquivo, s.sisdsc, s.sisurl, s.sisabrev, s.sisexercicio, s.paginainicial, p.pflnivel, us.susdataultacesso
		ORDER BY us.susdataultacesso DESC
		LIMIT 1",
		$usuario->usucpf
	);

	$sistema = (object) $db->pegaLinha( $sql );
	if ( !$sistema->sisid ) {
		erro( $alerta['permissao'] );
	}
	// carrega os dados do mdulo para a sesso
	foreach ( $sistema as $attribute => $value ) {
		$_SESSION[$attribute] = $value;
	}

	// atribui o ano atual para o exerccio das tarefas
	$_SESSION['exercicio_atual'] = $db->pega_ano_atual();
	$_SESSION['exercicio'] = $db->pega_ano_atual();

	unset($_SESSION['superuser']);
	$_SESSION['superuser'] = $db->testa_superuser( $usuario->usucpf );

	//dbg($_SESSION['superuser'],1,'00267967160');
	// atualiza a data de ltimo acesso no mdulo selecionado
	$_SESSION['usuacesso'] = date( 'Y/m/d H:i:s' );
	$sql = sprintf(
		$sql = "UPDATE seguranca.usuario_sistema SET susdataultacesso = '%s' where usucpf = '%s' and sisid = %d",
		$_SESSION['usuacesso'],
		$usuario->usucpf,
		$sistema->sisid
	);
	$db->executar( $sql );

	$totmsg=0;
	unset($_SESSION['mostramsg']);
	$sql = "select count(msgid) as totmsg from mensagemusuario where usucpf = '".$_SESSION['usucpf']."' and msulida ='f' and msuexcluida='f'";
	$_SESSION['mostramsg']=$db->pegaUm($sql);

	/*
	 * O contador de tempo online na tela deve ser atualizado toda vez que o
	 * usurio carregar uma tela do sistema. Ele  utilizado pelo "estou vivo"
	 * de acordo com a constante MAXONLINETIME, definido no config.inc.
	 */
	$_SESSION["evHoraUltimoAcesso"] = time();

	// leva o usurio para a tela inicial do mdulo selecionado
	$db->commit();

	$header = sprintf(
		"Location: ../%s/%s.php?modulo=%s",
		$sistema->sisdiretorio,
		$sistema->sisarquivo,
		$sistema->paginainicial
	);
	
	header( $header );
	exit();

?>